#property indicator_chart_window //   
#property indicator_buffers 5
#property indicator_color1 Magenta // 
#property indicator_color3 Green // . . 
#property indicator_color4 Red // . . 
//  
extern double OverSold=20; //    %% ( =100- )
extern int K=5; // %K
extern int Slow=3; // 
extern int SlowMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int applied_price=0; // 0-High&Low, 1-Close&Close
extern int ShowZigZag=1; //  1 -   , 2 -   
extern int ShowChannel=1; //  1 -   , 2 -   
// .
double   ZZpeak[], // 
         ZZtrough[], // 
         ChTop[], // . . 
         ChBot[], // . . 
         Stoch[]; // Stoch
//  
double OverBought; //  
bool dir; // 0- , 1 - 
double max,min; //  ., 
double top,bot; // , 
int jt,jp; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   OverBought=100.0-OverSold; //  
//---- indicators
   SetIndexBuffer(0,ZZpeak);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Peak");
   
   SetIndexBuffer(1,ZZtrough);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Trough");
   
   if(ShowZigZag>0) {
      SetIndexStyle(0,DRAW_ZIGZAG);
      SetIndexStyle(1,DRAW_ZIGZAG);
     }
   else {      
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
     }

   SetIndexBuffer(2,ChTop);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"ChTop");

   SetIndexBuffer(3,ChBot);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"ChBot");

   if(ShowChannel>0) {
      SetIndexStyle(2,DRAW_LINE);
      SetIndexStyle(3,DRAW_LINE);
     }
   else {      
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
     }

   SetIndexBuffer(4,Stoch);
   SetIndexStyle(4,DRAW_NONE);
   string _st="St("+K+", "+Slow+") "+SlowMethod+", "+applied_price;
   SetIndexLabel(4,_st);

//----
   IndicatorShortName("ZZ@Stoch"); 

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit();
   int limit=Bars-ic-1; // - 

   for(int i=limit; i>=0; i--) Stoch[i]=iStochastic(NULL,0,K,1,Slow,SlowMethod,applied_price, 0,i); 

   for(i=limit; i>0; i--)
     {
      double st=Stoch[i];
      jt++; jp++;

      if(dir) {
         if(st>=OverBought) {
            int sh=ArrayMinimum(Low,jt,i);
            bot=Low[sh]; //  = 
            if(ShowZigZag==1) ZZtrough[sh]=bot; else ZZtrough[i]=bot;
            if(ShowChannel==1) for(int k=sh; k>i; k--) ChBot[k]=bot;
            dir=0; //  
            jp=0;
           }
        }
      else {
         if(st<=OverSold) {
            sh=ArrayMaximum(High,jp,i);
            top=High[sh];
            if(ShowZigZag==1) ZZpeak[sh]=top; else ZZpeak[i]=top;
            if(ShowChannel==1) for(k=sh; k>i; k--) ChTop[k]=top;
            dir=1;
            jt=0;
           }
        }

      for(k=0; k<2; k++) {ChTop[i-k]=top; ChBot[i-k]=bot;}
     }
        
   return(0);
  }


// -  
int reinit()
  {
   ArrayInitialize(ZZpeak,0.0);
   ArrayInitialize(ZZtrough,0.0);
   ArrayInitialize(ChTop,0.0);
   ArrayInitialize(ChBot,0.0);
   ArrayInitialize(Stoch,0.0);
   dir=0;max=0;min=0;top=0;bot=0;jt=0;jp=0;
   return(0);
  }

